document.addEventListener("DOMContentLoaded", (event) => {
    htmx.config.scrollBehavior = "auto";
    const supportsViewTransitions = !!document.startViewTransition;
    if (!supportsViewTransitions) {
        const body = document.querySelector('body');
        body.classList.add('view-transition-fallback');
    }

    // Work around https://github.com/bigskysoftware/htmx/issues/1384 to ensure the
    // correct attributes (especially classes) are applied during a routing event.
    document.body.addEventListener('htmx:afterSwap', function(evt) {
        const parser = new DOMParser();
        const parsedResponse = parser.parseFromString(evt.detail.xhr.response, "text/html");
        const bodyAttributes = parsedResponse.getElementsByTagName('body')[0].attributes;
        for (const attribute of bodyAttributes) {
            evt.detail.target.setAttribute(attribute.name, attribute.value);
        }
        if (!supportsViewTransitions) {
            evt.detail.target.classList.add('view-transition-fallback-settling');
        }
    });

    // Trigger fallback transitions after settle
    document.body.addEventListener('htmx:afterSettle', function(evt) {
        if (!supportsViewTransitions) {
            evt.detail.target.classList.remove('view-transition-fallback-settling');
            evt.detail.target.classList.add('view-transition-fallback-settled');
        }
    });
});
